AutoMidHandle True
Global entitylist:TList = New TList	'entitylist

Global camrotpiv:entity = entity.Create(Null,Null)
Global cammovepiv:entity = entity.Create(Null,camrotpiv:entity)
camrotpiv.move(GraphicsWidth()/2,GraphicsHeight()/2)





Type entity
	Field image:TImage	'the image for the entity
	Field parent:entity	'for parenting system
	
	Field x:Float	'used for b3d-like turnentity and moveentity
	Field y:Float	'not reset every frame
	Field angle:Float
	
	Field x2:Float	'used for b3d-like rotateentity and positionentity
	Field y2:Float	'values reset every frame
	Field angle2:Float
	
	Field sclx:Float	'scale values for scaleentity command
	Field scly:Float
	
	Field s2x:Float	'carries scale properties for parenting
	Field s2y:Float
	
	Field alph:Float	'alpha
	Field bmod:Int	'blendmode
	
	Field r:Int	'red green blue values for entitycolor command
	Field g:Int
	Field b:Int
	
	Field frm:Int
	
	Function Create:entity(image:TImage = Null,parent:entity = Null)	'create entity.  If no image is specified then it is a pivot.  parent parameter is also optional
		Local e:entity = New entity
		
		If image Then
			e.image = image
		EndIf
		If parent:entity <> Null Then
			e.parent:entity = parent:entity
		EndIf
		
		e.alph = 1	'set default values
		e.r = 255
		e.g = 255
		e.b = 255
		e.bmod = alphablend
		e.sclx = 1
		e.scly = 1
		
		entitylist.addlast(e:entity)
		
		Return e:entity
	End Function
	
	Function Createglpiv:entity(image:TImage = Null,parent:entity)		'create entity.  If no image is specified then it is a pivot.  parent parameter is also optional
		Local e:entity = New entity
		
		If image Then
			e.image = image
		EndIf
		If parent:entity <> Null Then
			e.parent:entity = parent:entity
		EndIf
		
		e.alph = 1	'set default values
		e.r = 255
		e.g = 255
		e.b = 255
		e.bmod = alphablend
		e.sclx = 1
		e.scly = 1
		
		entitylist.addlast(e:entity)
		
		Return e:entity
	End Function
	
	Method rotate(a#)
		angle2 = a#
	End Method
	
	Method turn(a#)
		angle = angle + a#
	End Method
	
	Method move(xx#,yy#)
		x = x + xx
		y = y + yy
	End Method
	
	Method position(xx#,yy#)
		x2 = xx
		y2 = yy
	End Method
	
	Method setparent(p:entity)
		parent:entity = p:entity
		entitylist.remove(Self)
		entitylist.addlast(Self)	'moves itself to the end for parenting purposes
	End Method
	
	Method getparent:entity()
		Return parent:entity
	End Method
	
	Method color(rr:Int,gg:Int,bb:Int)
		r = rr
		g = gg
		b = bb
	End Method
	
	Method scale(sx#,sy#)
		sclx = sx#
		scly = sy#
	End Method
	
	Method Alpha(a#)
		alph = a
	EndMethod
	
	Method blendmode(b:Int)
		bmod = b
	End Method
	
	Method red:Int()
		Return r
	End Method
	Method green:Int()
		Return g
	End Method
	Method blue:Int()
		Return b
	End Method
	
	Method getx:Float()
		Return x+x2
	End Method
	Method gety:Float()
		Return y+y2
	End Method
	
	Method getangle:Float()
		Return angle+angle2
	End Method
	
	Method getblendmode:Int()
		Return bmod
	End Method
	
	Method getimage:TImage()
		Return image:TImage
	End Method
	
	Method setimage(i:TImage)
		image:TImage = i:TImage
	End Method
	
	Method setframe(f:Int)
		frm = f
	End Method
	
	Method getframe:Int()
		Return frm
	End Method
	
End Type


Function Render()



For Local e:entity = EachIn entitylist
	If e.parent:entity Then
		e.angle2 :+ e.parent.angle2
		e.s2x = e.sclx*e.parent.s2x
		e.s2y = e.scly*e.parent.s2y
		e.x2 :+ e.parent.x2
		e.y2 :+ e.parent.y2
		
		Local xt# = e.x*e.parent.s2x
		Local yt# = e.y*e.parent.s2y
		Local d# = Sqr((yt*yt)+(xt*xt))
		Local t2# = ATan2(yt,xt)
		e.x2 :+ Cos(t2+e.parent.angle2)*d
		e.y2 :+ Sin(t2+e.parent.angle2)*d
		
	ElseIf e:entity = camrotpiv Then
		e.s2x = e.sclx
		e.s2y = e.scly
		e.x2 :+ e.x
		e.y2 :+ e.y
	Else
		Local par:entity = cammovepiv:entity
		e.angle2 :+ par.angle2
		e.s2x = e.sclx*par.s2x
		e.s2y = e.scly*par.s2y
		e.x2 :+ par.x2
		e.y2 :+ par.y2
		
		Local xt2# = e.x*par.s2x
		Local yt2# = e.y*par.s2y
		Local d2# = Sqr((yt2*yt2)+(xt2*xt2))
		Local t22# = ATan2(yt2,xt2)
		e.x2 :+ Cos(t22+par.angle2)*d2
		e.y2 :+ Sin(t22+par.angle2)*d2
	EndIf
	
	e.angle2 :+ e.angle
	
	
	SetRotation e.angle2
	SetScale e.s2x,e.s2y
	SetColor e.r,e.g,e.b
	SetBlend e.bmod
	SetAlpha e.alph
	
	If e.image Then DrawImage e.image,e.x2,e.y2,e.frm
Next

For Local e2:entity = EachIn entitylist
	e2.x2 = 0
	e2.y2 = 0
	e2.angle2 = 0
	e2.s2x = 0
	e2.s2y = 0
Next

End Function
